

# get grid info
ntarget <- 6400
dim <- 3
nn3 <- round(ntarget^(1/dim))
nvec3 <- rep(nn3,dim)
n3 <- prod(nvec3)
dim <- 4
nn4 <- round(ntarget^(1/dim))
nvec4 <- rep(nn4,dim)
n4 <- prod(nvec4)
rngvec <- c(10,20,40)
smvec <- c(5)
mvec <- seq(30,240,by=30)
mm <- length(mvec)
    
# load in the results

pdf("numstudy_3D_4D_ungrouped_kldiv.pdf",width=9,height=6)
layout( matrix( 1:6, 2, 3, byrow = TRUE ) )

par(mar=c(4,4,3,1))
load("results/numstudy_3D.RData")
for( r in 1:3 ){
    plot( mvec, log10(kldiv[ , 1, 1, 1, 1 ]), type = "n",
          ylim = c(-3.5,2.0), axes = FALSE,xlim=c(20,240),
          xlab = "", ylab = "", family = "serif" )
    pchvec <- c(0,4,1,3)
    ord <- c(3,5,2,1)
    for( ordi in 1:4 ){
        lines( mvec, log10(kldiv[ , ord[ordi], 1, r, 1 ]), type = "l", pch = pchvec[ordi], col = "gray"  )
        points( mvec, log10(kldiv[ , ord[ordi], 1, r, 1 ]), type = "p", pch = pchvec[ordi])
    }
    axis(1,at = mvec, lwd = 0, lwd.ticks = 1, labels = c("",60,"",120,"",180,"",240), family = "serif")
    axis(2,at = -4:3, lwd = 0, lwd.ticks = 1, family = "serif")
    box()
    if(r == 1){
        points( rep(120,4), c(1.8,1.2,0.6,0.0), pch = pchvec )
        text( rep(130,4), c(1.8,1.2,0.6,0.0), c("sorted coord.","middle out","random","MMD"),
              family = "serif", pos = 4 )
    }
    mtext(paste0("3D, range = ",rngvec[r]/100), line = 1, family = "serif")
    mtext("Neighbors", line = 2.5, side = 1, cex = 0.8, family = "serif")
    mtext("log 10 KL Divergence", line = 2.5, side = 2, cex = 0.8, family = "serif")
}

load("results/numstudy_4D.RData")
for( r in 1:3 ){
    plot( mvec, log10(kldiv[ , 1, 1, 1, 1 ]), type = "n",
          ylim = c(-3.5,2.0), axes = FALSE,xlim=c(20,240),
          xlab = "", ylab = "", family = "serif" )
    pchvec <- c(0,4,1,3)
    ord <- c(3,5,2,1)
    for( ordi in 1:4 ){
        lines( mvec, log10(kldiv[ , ord[ordi], 1, r, 1 ]), type = "l", pch = pchvec[ordi], col = "gray"  )
        points( mvec, log10(kldiv[ , ord[ordi], 1, r, 1 ]), type = "p", pch = pchvec[ordi])
    }
    axis(1,at = mvec, lwd = 0, lwd.ticks = 1, labels = c("",60,"",120,"",180,"",240), family = "serif")
    axis(2,at = -4:3, lwd = 0, lwd.ticks = 1, family = "serif")
    box()
    mtext(paste0("4D, range = ",rngvec[r]/100), line = 1, family = "serif")
    mtext("Neighbors", line = 2.5, side = 1, cex = 0.8, family = "serif")
    mtext("log 10 KL Divergence", line = 2.5, side = 2, cex = 0.8, family = "serif")
}
dev.off()










pdf("numstudy_3D_4D_grouped_kldiv.pdf",width=9,height=6)
layout( matrix( 1:6, 2, 3, byrow = TRUE ) )

par(mar=c(4,4,3,1))
load("results/numstudy_3D.RData")
for( r in 1:3 ){
    plot( mvec, log10(kldiv[ , 1, 1, 1, 1 ]), type = "n",
          ylim = c(-5,2.0), axes = FALSE,xlim=c(20,240),
          xlab = "", ylab = "", family = "serif" )
    pchvec <- c(0,4,1,3)
    ord <- c(3,5,2,1)
    for( ordi in 1:4 ){
        lines( mvec, log10(kldiv[ , ord[ordi], 2, r, 1 ]), type = "l", pch = pchvec[ordi], col = "gray"  )
        points( mvec, log10(kldiv[ , ord[ordi], 2, r, 1 ]), type = "p", pch = pchvec[ordi])
    }
    axis(1,at = mvec, lwd = 0, lwd.ticks = 1, labels = c("",60,"",120,"",180,"",240), family = "serif")
    axis(2,at = -4:3, lwd = 0, lwd.ticks = 1, family = "serif")
    box()
    if(r == 1){
        points( rep(120,4), c(1.8,1.2,0.6,0.0), pch = pchvec )
        text( rep(130,4), c(1.8,1.2,0.6,0.0), c("sorted coord.","middle out","random","MMD"),
              family = "serif", pos = 4 )
    }
    mtext(paste0("3D, range = ",rngvec[r]/100), line = 1, family = "serif")
    mtext("Neighbors", line = 2.5, side = 1, cex = 0.8, family = "serif")
    mtext("log 10 KL Divergence", line = 2.5, side = 2, cex = 0.8, family = "serif")
}

load("results/numstudy_4D.RData")
for( r in 1:3 ){
    plot( mvec, log10(kldiv[ , 1, 1, 1, 1 ]), type = "n",
          ylim = c(-5,2.0), axes = FALSE,xlim=c(20,240),
          xlab = "", ylab = "", family = "serif" )
    pchvec <- c(0,4,1,3)
    ord <- c(3,5,2,1)
    for( ordi in 1:4 ){
        lines( mvec, log10(kldiv[ , ord[ordi], 2, r, 1 ]), type = "l", pch = pchvec[ordi], col = "gray"  )
        points( mvec, log10(kldiv[ , ord[ordi], 2, r, 1 ]), type = "p", pch = pchvec[ordi])
    }
    axis(1,at = mvec, lwd = 0, lwd.ticks = 1, labels = c("",60,"",120,"",180,"",240), family = "serif")
    axis(2,at = -4:3, lwd = 0, lwd.ticks = 1, family = "serif")
    box()
    mtext(paste0("4D, range = ",rngvec[r]/100), line = 1, family = "serif")
    mtext("Neighbors", line = 2.5, side = 1, cex = 0.8, family = "serif")
    mtext("log 10 KL Divergence", line = 2.5, side = 2, cex = 0.8, family = "serif")
}
dev.off()
