
plotreleff1 <- FALSE
plotreleff2 <- FALSE
plotkldiv <-FALSE
plotsimexamples <- FALSE


if(plotreleff1){
# whole new plot to try to combine all six scenarios into one, just plotting
# 30 and 60 neighbors
nvecvec = 80
rngvec = c(10,20)
smvec = c(5,10,15)
neighvec <- c(3,6)

for( neighind in 1:2){

neighs <- 10*neighvec[neighind]

postscript(file=paste("paper/figures/releff_",neighs,".eps",sep=""),width=9,height=4.5,horizontal = FALSE,
           onefile = FALSE, paper = "special")

fig1 <- c(0,0.36,0.68,1)
fig2 <- c(0,1/2,1)
mar1 <- c(3,1,1)
par(oma=c(0,0,0,0))
plot.new()
for( j1 in 1:length(nvecvec)){
for( j2 in 1:length(rngvec)){
for( j3 in 1:length(smvec)){
nvec = nvecvec[j1]
rng = rngvec[j2]
sm = smvec[j3]
covparms = c(1, rng/100, sm/10, 1)
fname <- paste("results/numstudy4_n",nvec[1],"_rng",round(covparms[2]*100),
               "_sm",round(covparms[3]*10),".Rdata",sep="")
load(fname)
print(c(rng,sm))
print(releff[c(3,6),,,])

par(fig=c( fig1[j3],fig1[j3+1],fig2[j2],fig2[j2+1] ),new=TRUE,mar=c(1.5,mar1[j3],1,1) )
plot(c(0,0),xlim=c(1/2,7),axes=FALSE,ylim=c(0.8,4.3),type="n",
     xlab="", ylab="",
     main = paste("Range = ",round(covparms[2],2),
                  " Smooth = ",round(covparms[3],2)), cex.main=0.7)
ord <- c(4,3,5,2,1)
for( parm in 1:3 ){
    for( neigh in neighvec[neighind] ){
        for( ordi in 1:5 ){
            points( (parm-1)*2.25 + 1 + (ordi-1)/3, -log10(1-releff[neigh,parm,ord[ordi],1]),pch=ordi,col="black",cex=1)
            points( (parm-1)*2.25 + 1 + (ordi-1)/3, -log10(1-releff[neigh,parm,ord[ordi],2]),pch=ordi,col="magenta",cex=1)
        }
    }
}
box()
axis(2,at=c(1,2,3,4),labels=rep("",4),cex.axis=0.7,lwd=0,lwd.ticks=1,line=0)
if(j3==1){
    mtext("relative efficiency (%)",side=2,line=1.7,cex=0.7)
}
mtext("90",at=1,side=2,line=0.6,cex=0.7)
mtext("99",at=2,side=2,line=0.6,cex=0.7)
mtext("99.9",at=3,side=2,line=0.6,cex=0.7)
mtext("99.99",at=4,side=2,line=0.6,cex=0.7)
mtext("Variance",side=1,line=0,at=1.5,cex=0.7)
mtext("Range",side=1,line=0,at=3.8,cex=0.7)
mtext("Smooth",side=1,line=0,at=6.2,cex=0.7)
for(j in 1:4) abline(j,0,col="gray")
}}}

dev.off()
}

}


if(plotreleff2){
# Same as above, but take out the distant one, comebine 30 and 60
nvecvec = 80
rngvec = c(10,20)
smvec = c(5,10,15)
neighvec <- c(3,6)
pchvec <- c(0,4,1,3)

for( neighind in 1:2){

    neighs <- 10*neighvec[neighind]

    postscript(file="paper/figures/releff.eps",width=9,height=4.5,horizontal = FALSE,
               onefile = FALSE, paper = "special")

    fig1 <- c(0,0.37,0.69,1)
    fig2 <- c(0,1/2,1)
    mar1 <- c(3,0,0)
    par(oma=c(0,0,0,0))
    plot.new()
    for( j1 in 1:length(nvecvec)){
        for( j2 in 1:length(rngvec)){
            for( j3 in 1:length(smvec)){
                nvec = nvecvec[j1]
                rng = rngvec[j2]
                sm = smvec[j3]
                covparms = c(1, rng/100, sm/10, 1)
                fname <- paste("results/numstudy4_n",nvec[1],"_rng",round(covparms[2]*100),
                               "_sm",round(covparms[3]*10),".Rdata",sep="")
                load(fname)
                par(fig=c( fig1[j3],fig1[j3+1],fig2[3-j2],fig2[3-j2+1] ),new=TRUE,mar=c(1.5,mar1[j3],1,0.1) )
                plot(c(0,0),xlim=c(1/2,7),axes=FALSE,ylim=c(0.7,4.3),type="n",
                     xlab="", ylab="",
                     main = paste("Range = ",round(covparms[2],2),
                                  " Smooth = ",round(covparms[3],2)), cex.main=0.7)
                ord <- c(3,5,2,1)
                for( parm in 1:3 ){
                    for( neigh in 1:2 ){
                        for( ordi in 1:4 ){
                            points( -1/2 + (neigh-1)*1.1 + (parm-1)*2.3 + 1 + (ordi-1)/5, -log10(1-releff[neighvec[neigh],parm,ord[ordi],1]),pch=pchvec[ordi],col="black",cex=1)
                            points( -1/2 + (neigh-1)*1.1 + (parm-1)*2.3 + 1 + (ordi-1)/5, -log10(1-releff[neighvec[neigh],parm,ord[ordi],2]),pch=pchvec[ordi],col="magenta",cex=1)
                        }
                    }
                }
                box()
                axis(2,at=c(1,2,3,4),labels=rep("",4),cex.axis=0.7,lwd=0,lwd.ticks=1,line=0)
                if(j3==1){
                    mtext("relative efficiency (%)",side=2,line=1.7,cex=0.7)
                    mtext("90",at=1,side=2,line=0.6,cex=0.7)
                    mtext("99",at=2,side=2,line=0.6,cex=0.7)
                    mtext("99.9",at=3,side=2,line=0.6,cex=0.7)
                    mtext("99.99",at=4,side=2,line=0.6,cex=0.7)
                }
                mtext("Variance",side=1,line=0,at=1.5,cex=0.7)
                mtext("Range",side=1,line=0,at=3.8,cex=0.7)
                mtext("Smooth",side=1,line=0,at=6.0,cex=0.7)
                text(rep(c(0,1),3) + rep(c(0.9,3.2,5.5),each=2) ,rep(0.85,6),c("30","60"),cex=0.7)
                for(j in 1:4) abline(j,0,col="gray")
                
                if(j2==2 && j3==3){
                    points(c(0.5,2.8,0.5,2.8),c(3.8,3.8,4.2,4.2),pch=pchvec)
                    text(c(0.5,2.8,0.5,2.8),c(3.8,3.8,4.2,4.2),c("sorted coord.","middle out","random","MMD"),pos=4,cex=0.7)
                    points(rep(c(5.1),each=8),rep(c(3.8,4.2),each=4),pch=rep(pchvec,2),col=rep(c("black","magenta"),each=4))
                    text(c(5.1,5.2),c(3.8,4.2),c("ungrouped","grouped"),cex=0.7,pos=4)
                }    
    }}}

    dev.off()
}

}


if(plotkldiv){

# plot kldiv as a function of timing

fname <- "results/numstudy_n80_KL_timing_taper_spde_cpp5.Rdata"
load(fname)
nvecvec = 80
rngvec = c(10,20)
smvec = c(5,10,15)
ord <- c(3,5,2,1)
xlm1 <- log(c(1/16,1/4,1/16))
xlm2 <- log(c(3,6,3))
xlmticks <- list((2^(-4:1)),(2^(-2:2)),(2^(-4:1)) )
xlmlabs <- list(c("1/16","1/8","1/4","1/2","1","2"),
                c("1/4","1/2","1","2","4"),
                c("1/16","1/8","1/4","1/2","1","2") )
fig1 <- c(0,0.36,0.68,1)
fig2 <- c(0,1/2,1)
mar1 <- c(3,1,1)
pchvec <- c(0,4,1,3)
arr3060x <- array(c(0.17,0.17,0.45,0.45,0.16,0.16,0.9,0.9,4.8,4.8,0.85,0.85),c(2,3,2))
arr3060y <- array(c(1/2,1/2,-1/2,-1/2,3/2,3/2,-1/2,-1/2,-1/2,-1/2,1/2,1/2),c(2,3,2))

pdf(file="paper/figures/kldiv_spde_taper_cpp1.pdf",width=8,height=5.5)
par(oma=c(0,0,0,0))
plot.new()
for( j2 in 1:length(rngvec)){
    for( j3 in 1:length(smvec)){
        rng = rngvec[j2]
        sm = smvec[j3]
        covparms = c(1, rng/100, sm/10, 1)
        par(fig=c( fig1[j3],fig1[j3+1],fig2[3-j2],fig2[3-j2+1] ),new=TRUE,mar=c(3,mar1[j3],1.5,1) )
        plot(0,xlim=c(xlm1[j3],xlm2[j3]),ylim=c(-3.5,3),type="n",ann=FALSE,axes=FALSE)
        for(ll in -3:3) abline(ll,0,col="gray")
        #for( ordi in 1:5 ){
        for(ordi in 1:4){
            for( neighind in 1:2 ){
                points( log(timing[neighind,ord[ordi],1,j2,j3]), log10(kldiv[neighind,ord[ordi],1,j2,j3]), col="black", pch=pchvec[ordi], cex=1 )
                points( log(timing[neighind,ord[ordi],2,j2,j3]), log10(kldiv[neighind,ord[ordi],2,j2,j3]), col="magenta", pch = pchvec[ordi], cex=1 )
                #lines( log(timing[neighind,ord[ordi],1:2,j2,j3]),log10(kldiv[neighind,ord[ordi],1:2,j2,j3]), col="gray" )
            }
        }
        points( log(timing[1,1,3,j2,j3]), log10(kldiv[1,1,3,j2,j3]), col="blue", pch=16, cex=1 )
        points( log(timing[1,1,4,j2,j3]), log10(kldiv[1,1,4,j2,j3]), col="blue", pch=17, cex=1 )
        if(j3==2){  # spde triangles
            for(k in 3:3){  # this is the fastest one
                points( log(timing[1,k,5,j2,j3]), log10(kldiv[1,k,5,j2,j3]), col="red", pch=17,cex=1 )
            }
        }
        if(j3==1){  # tapering diamonds
            for(k in 1:3){
                points( log(timing[1,k,6,j2,j3]), log10(kldiv[1,k,6,j2,j3]), col="black", pch=18,cex=1 )
            }
        }
        box()
        xticks <- xlmticks[[j3]]
        xlabs <- xlmlabs[[j3]]
        axis(1,at=log(xticks),labels=rep("",length(xticks)),lwd=0,lwd.ticks=1,cex.axis=0.7)
        for(k in 1:length(xticks)) mtext(xlabs[k],side=1,line=0.5,at=log(xticks[k]),cex=0.7)
        axis(2,lwd=0,lwd.ticks=1,cex.axis=0.7)
        if(j3==1) mtext("log10 KL Divergence",side=2,line=2,cex=1)
        mtext("Time (seconds)",side=1,line=1.5,cex=0.7)
        mtext(paste("Range = ",round(covparms[2],2)," Smooth = ",round(covparms[3],2)),side=3,cex=0.8,line=0.5)

        # 30 and 60 labels
        text(log(arr3060x[j2,j3,1]),arr3060y[j2,j3,1],"30",cex=0.7)
        text(log(arr3060x[j2,j3,2]),arr3060y[j2,j3,2],"60",cex=0.7)

        if(j2==2 && j3==3){
            points(log(c(0.07,0.5,0.07,0.5)),c(-1.7,-1.7,-2.3,-2.3),pch=pchvec)
            text(log(c(0.07,0.5,0.07,0.5)),c(-1.7,-1.7,-2.3,-2.3),c("sorted coord.","middle out","random","MMD"),pos=4,cex=0.7)
            points(log(rep(c(0.07,0.5),each=4)),rep(c(-3.3,-3.3),each=4),pch=rep(pchvec,2),col=rep(c("black","magenta"),each=4))
            text(log(c(0.07,0.5)),c(-3.3,-3.3),c("ungrouped","grouped"),cex=0.7,pos=4)
        }
        if(j2==2 && j3==2){
            points(log(c(0.3,1,3)),rep(-2.7,3),pch=c(17,16,17),col=c("blue","blue","red"))
            text(log(c(0.3,1,3)),rep(-2.7,3),c("9 blocks","4 blocks","SPDE"),cex=0.7,pos=4)
        }
        if(j2==2 && j3==1){
            points(log(c(1)),c(-2.7),pch=c(18),col=c("black"))
            text(log(c(1)),c(-2.7),c("tapering"),cex=0.7,pos=4)
        }
}}
dev.off()

# comparisons in paper
cat("Abstract\n")
print( kldiv[1,3,1,1,1]/kldiv[1,1,2,1,1] )
print( kldiv[1,3,1,2,1]/kldiv[1,1,2,2,1] )
print( timing[1,3,1,1,1]/timing[1,1,2,1,1] )
print( timing[1,3,1,2,1]/timing[1,1,2,2,1] )

cat("\n nu = 1/2\n")
print( kldiv[1,3,1,1,1]/kldiv[1,1,1,1,1] )
print( kldiv[1,3,1,2,1]/kldiv[1,1,1,2,1] )
print( timing[1,3,1,1,1]/timing[1,1,2,1,1] )
print( kldiv[1,3,1,1,1]/kldiv[1,1,2,1,1] )
print( kldiv[1,3,1,2,1]/kldiv[1,1,2,2,1] )
print( kldiv[2,3,1,1,1]/kldiv[2,1,2,1,1] )
print( kldiv[2,3,1,2,1]/kldiv[2,1,2,2,1] )
print( timing[2,3,1,1,1]/timing[2,1,2,1,1] )
print( timing[2,3,1,2,1]/timing[2,1,2,2,1] )
print(kldiv[1,1,6,1,1]/kldiv[1,1,2,1,1])
print(kldiv[1,1,6,2,1]/kldiv[1,1,2,2,1])

cat("\n nu = 1\n")
print( kldiv[1,4,5,1,2]/kldiv[1,1,2,1,2] )
print( kldiv[1,4,5,2,2]/kldiv[1,1,2,2,2] )
print( timing[1,4,5,1,2]/timing[1,1,2,1,2] )
print( timing[1,4,5,2,2]/timing[1,1,2,2,2] )


}


if( plotsimexamples ){

sapply(list.files(pattern="[.]R$", path="R/", full.names=TRUE), source);

nvecvec = 80
rngvec = c(10,20)
smvec = c(5,10,15)
locs <- simulateGrid(c(nvecvec,nvecvec))

postscript(file="paper/figures/simexamples.eps",width=6,height=4,horizontal = FALSE,
           onefile = FALSE, paper = "special")
layout(matrix(c(1,4,2,5,3,6),2,3),widths=c(1/3,1/3,1/3),heights=c(1/2,1/2))
par(oma=c(0,0,0,0),mar=c(1,1,2,1))
for( j2 in 1:length(rngvec)){
    for( j3 in 1:length(smvec)){
        rng = rngvec[j2]
        sm = smvec[j3]
        covparms = c(2, rng/100, sm/10, 1)
        covmat <- maternIsotropic(locs,covparms)
        cholmat <- t(chol(covmat))
        zvec <- cholmat %*% rnorm(nrow(locs))
        zmat <- matrix(zvec,nvecvec,nvecvec)
        image(zmat,zlim=c(-6,6),col=tim.colors(64),axes=FALSE,ann=FALSE)   
        mtext(paste("Range = ",round(covparms[2],2)," Smooth = ",round(covparms[3],2)),side=3,cex=0.8,line=0.5)
        box()
}}
dev.off()

}

